const ZinTest = function(runner, jbm) {
	this.logger = runner.logger;
	this.jbm = jbm;
	this.logger.log("creating ZinTest with ", runner, jbm);
}
ZinTest.prototype.data = function(cx, zn, fl) {
	zn = cx.full(zn);
	fl = cx.full(fl);
	this.jbm.data(cx, zn, fl);
}
ZinTest.prototype.user = function(cx, zn, u) {
	zn = cx.full(zn);
	u = cx.full(u);
	this.jbm.user(cx, zn, u);
}
ZinTest.prototype.attach = function(cx, zn, u) {
	zn = cx.full(zn);
	u = cx.full(u);
	this.jbm.attach(cx, zn, u);
}
ZinTest.prototype.obtainDataEntry = function(cx, zn, ziid, ty, iv) {
	zn = cx.full(zn);
	ziid = cx.full(ziid);
	ty = cx.full(ty);
	var self = this;
	this.jbm.obtainDataEntry(cx, zn, ziid, ty, { result: function(s) {
		self.logger.log("have obtained ", s);
		var jp = JSON.parse(s);
		self.logger.log("parsed as ", jp);
		var trav = new ListTraverser(cx, new CollectingState(cx));
		var jb = new JsonBeachhead(cx, null, null, null);
		try {
			jb.handleArg(trav, jp);
			self.logger.log("concluded with", trav.ret[0]);
			iv.bindActual(trav.ret[0]);	
		} catch (e) {
			self.logger.log("error was", e);
			self.logger.log("error at", e.stack);
		}
	}});
}

//--EXPORT
/* istanbul ignore else */ 
if (typeof(module) !== 'undefined') {
	module.exports = ZinTest;
} else {
//--WINDOW
	window.ZinTest = ZinTest;
	window.UTRunner.modules['org.ziniki.storage.memory.ZinikiTestModule'] = ZinTest;
}